const { Command, version: akairoVersion } = require('discord-akairo');
const { version: djsVersion } = require('discord.js');

class AboutCommand extends Command {
    constructor() {
        super('about', {
            aliases: ['about'],
            clientPermissions: ['SEND_MESSAGES']
        });
    }

    exec(message) {
        return message.util.send([
            'Compiler runs on Myriad, a Docker-based arbitrary code evaluation server!',
            'Check it out here <https://github.com/1Computer1/myriad>.',
            '',
            `**Guilds**: ${this.client.guilds.cache.size}`,
            `**Channels**: ${this.client.channels.cache.size}`,
            `**Users**: ${this.client.users.cache.size}`,
            '',
            `**Memory Usage**: ${(process.memoryUsage().heapUsed / 1024 / 1024).toFixed(2)} MB`,
            `**Discord.js**: v${djsVersion}`,
            `**Akairo**: v${akairoVersion}`
        ]);
    }
}

module.exports = AboutCommand;
